
class StreamPipe;
class StreamElement;
class Swarm;

class SwarmElement : public StreamElement {
public:
    SwarmElement(
	StreamPipe* out,
	double linesPerSecond = 32.0, unsigned int _lines = 0,
	double _gain = 10.0, bool _doAbs = false,
	unsigned int Dims = 32, unsigned int GnatCount = 7,
	double accelFactor = 1.0
    );
    ~SwarmElement( void );

    int run( void );

private:
    void clearCoefs( void );
    void incCoefs( const double* incs );
    void emitCoefs( void );

    unsigned int Dims;
    Swarm* swarm;
    double* coefs;
    unsigned char* outBuffer;
    double lineTime;
    unsigned int lines;
    double gain;
    bool doAbs;
};
