
class StreamPipe;

class Tone : public StreamElement {

public:
    enum {
	SINE,
	TRIANGLE,
	SQUARE,
	SAWTOOTH,
	TOOTHSAW
    };

    Tone(
	StreamPipe* in, StreamPipe* out, double _freq,
	double _linesPerSecond = 64.0, double _gain = 1.0,
	unsigned int _waveType = SINE, double _gamma = 0.44,
	double _minHz = 128.0, double _maxHz = 4096.0
    );

    ~Tone( void );

protected:
    int run( void );

private:
    double freq;
    double linesPerSecond;
    double gain;
    unsigned int waveType;
    double minHz;
    double maxHz;

    double intensityMap[ 256 ];
};
