
class Bug;

class Swarm {

public:
    Swarm(
	unsigned int _Dims = 32, unsigned int _Gnats = 7,
	double duration = 1.5
    );
    ~Swarm( void );

    inline unsigned int getDims( void ) const {
	return this->Dims;
    };

    inline unsigned int getGnatCount( void ) const {
	return this->GnatCount;
    };

    inline const double* getTargetPos( void ) const {
	return this->target;
    };

    const double* getWaspPosition( void ) const;
    const double* getGnatPosition( unsigned int index ) const;

    void update( double elapsed );

    static double drand( void );
    static double randomCoord( void );
    static double randomVelocity( void );
    static double randomAcceleration( void );

private:
    bool done;
    unsigned int Dims;
    unsigned int GnatCount;
    double PointDuration;
    Bug* wasp;
    Bug* gnats;
    double* target;
    double timeUntilNextTarget;
};
